require "test_helper"

class UploadPartyLogoTest < ActionDispatch::IntegrationTest
  # test "the truth" do
  #   assert true
  # end

  test "upload logo for party" do
    get hello_path
    assert_response :success
    assert_select "legend", "Login"

    post '/sessions/create', params: { email: users(:citizen).email, password: 'titok' }, headers: { 'HTTP_REFERER': hello_path }
    assert_response :redirect
    assert_equal session[:user], users(:citizen).id
    follow_redirect!
    assert_select 'a', 'Parties'
    
    get parties_path
    assert_response :success
    assert_select 'tr', 2

    get page_parties_path(2)
    assert_response :success
    assert_select 'td', 'T3'

    get edit_party_path(parties(:maradek3).id)
    assert_response :success
    assert_select 'form', 1

    upload_file = fixture_file_upload('test/fixtures/files/logo.png', 'image/png')
    patch party_path(parties(:maradek3).id), headers: { "HTTP_REFERER": party_path(parties(:maradek3).id) }, params: { party: { logo: upload_file } }
    assert_response :redirect
    follow_redirect!
    assert_select 'div.logo', 1
    assert_equal Logo.all.size, 1
    assert File.exists? "public/data/#{Logo.last.id}"

    get '/sessions/destroy', headers: { 'HTTP_REFERER': hello_path }
    assert_response :redirect
    assert_nil session[:user]
    follow_redirect!
    assert_select 'legend', 'Login'
  end
end
